/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.municipalidad.contratos.view;

import com.municipalidad.contratos.adapter.ContratoAdapter;
import com.municipalidad.contratos.cont.ContratoCont;
import com.municipalidad.contratos.entities.ContratoType;
import com.municipalidad.contratos.cont.ExcelReader;
import com.municipalidad.contratos.entities.Contrato;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.io.File;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.attribute.standard.PrinterName;
import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.SpinnerNumberModel;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.filechooser.FileSystemView;
import javax.swing.table.DefaultTableModel;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperPrintManager;
import net.sf.jasperreports.swing.JRViewer;
import net.sf.jasperreports.view.JasperViewer;

/**
 *
 * @author martin
 */
public class ContratoView extends javax.swing.JFrame {

    private String listPath;
    private String outPath;
    private ContratoType type;
    private List<JComboBox> comboFieldList;
    private ContratoCont contratoCont;
    private List<List> data;
    private List<Contrato> contratos;
    private Integer contratosIndex = 0;

    /**
     * Creates new form ContratoView
     */
    public ContratoView() {
        initComponents();
        this.contratoCont = new ContratoCont();
        this.buttonGroup1.add(this.conRelacionRadioBtn);
        this.buttonGroup1.add(this.sinRelacionRadioBtn);
        //this.buttonGroup1.add(this.transitoRadioBtn);
        this.type = ContratoType.CON_RELACION;
        this.conRelacionRadioBtn.setSelected(true);
        comboFieldList = new LinkedList<>();
        comboFieldList.add(this.documentoCmb);
        comboFieldList.add(this.apellidoNombreCmb);
        comboFieldList.add(this.categoriaCmb);
        comboFieldList.add(this.dependenciaCmb);
        comboFieldList.add(this.duracionMesesCmb);
        comboFieldList.add(this.fechaDesdeCmb);
        comboFieldList.add(this.fechaHastaCmb);
        comboFieldList.add(this.montoMensualCmb);
        comboFieldList.add(this.montoTotalCmb);
        this.data = new LinkedList<>();
        this.disableNonRequiredFields();
        this.contratos = new LinkedList<>();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jFrame1 = new javax.swing.JFrame();
        exitBtn = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        tabbedPanel = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        listPathText = new javax.swing.JTextField();
        listPathChooserBtn = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel16 = new javax.swing.JLabel();
        cantidadRegistrosTxt = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        apellidoNombreCmb = new javax.swing.JComboBox<>();
        jLabel5 = new javax.swing.JLabel();
        documentoCmb = new javax.swing.JComboBox<>();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        duracionMesesCmb = new javax.swing.JComboBox<>();
        jLabel8 = new javax.swing.JLabel();
        fechaDesdeCmb = new javax.swing.JComboBox<>();
        fechaHastaCmb = new javax.swing.JComboBox<>();
        jLabel9 = new javax.swing.JLabel();
        montoTotalCmb = new javax.swing.JComboBox<>();
        jLabel10 = new javax.swing.JLabel();
        montoMensualCmb = new javax.swing.JComboBox<>();
        jLabel12 = new javax.swing.JLabel();
        conRelacionRadioBtn = new javax.swing.JRadioButton();
        sinRelacionRadioBtn = new javax.swing.JRadioButton();
        categoriaCmb = new javax.swing.JComboBox<>();
        jLabel11 = new javax.swing.JLabel();
        dependenciaCmb = new javax.swing.JComboBox<>();
        jLabel13 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel15 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jSeparator3 = new javax.swing.JSeparator();
        jPanel5 = new javax.swing.JPanel();
        previsualizationPnl = new javax.swing.JPanel();
        nextBtn = new javax.swing.JButton();
        prevBtn = new javax.swing.JButton();
        indexLbl = new javax.swing.JLabel();
        printBtn = new javax.swing.JButton();
        printersCmb = new javax.swing.JComboBox<>();
        desdeNum = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        hastaNum = new javax.swing.JSpinner();
        jLabel20 = new javax.swing.JLabel();
        copiasNum = new javax.swing.JSpinner();

        javax.swing.GroupLayout jFrame1Layout = new javax.swing.GroupLayout(jFrame1.getContentPane());
        jFrame1.getContentPane().setLayout(jFrame1Layout);
        jFrame1Layout.setHorizontalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        jFrame1Layout.setVerticalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        exitBtn.setText("Salir");
        exitBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitBtnActionPerformed(evt);
            }
        });

        jPanel1.setBackground(java.awt.Color.white);

        jLabel1.setFont(new java.awt.Font("Ubuntu", 1, 18)); // NOI18N
        jLabel1.setText("Impresion de contratos:");

        jLabel4.setText("Este programa exporta los contratos.");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel4))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel4)
                .addContainerGap(32, Short.MAX_VALUE))
        );

        tabbedPanel.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                tabbedPanelStateChanged(evt);
            }
        });

        jLabel3.setText("Selecciona el archivo fuente de datos (xlsx, xls):");

        listPathText.setEnabled(false);

        listPathChooserBtn.setText("Elegir archivo");
        listPathChooserBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                listPathChooserBtnActionPerformed(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        jLabel16.setText("Cantidad de registros:");

        cantidadRegistrosTxt.setText("0");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                                .addComponent(listPathText)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(listPathChooserBtn))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addContainerGap())
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cantidadRegistrosTxt)
                        .addGap(0, 0, Short.MAX_VALUE))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(listPathChooserBtn)
                    .addComponent(listPathText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(cantidadRegistrosTxt))
                .addContainerGap())
        );

        tabbedPanel.addTab("Fuente de datos", jPanel2);

        apellidoNombreCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel5.setFont(new java.awt.Font("Ubuntu", 1, 15)); // NOI18N
        jLabel5.setText("Tipo de contrato");

        documentoCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel6.setText("DNI");

        jLabel7.setText("Duracion del contrado");

        duracionMesesCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        duracionMesesCmb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                duracionMesesCmbActionPerformed(evt);
            }
        });

        jLabel8.setText("Fecha desde");

        fechaDesdeCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        fechaDesdeCmb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fechaDesdeCmbActionPerformed(evt);
            }
        });

        fechaHastaCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        fechaHastaCmb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fechaHastaCmbActionPerformed(evt);
            }
        });

        jLabel9.setText("Fecha hasta");

        montoTotalCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        montoTotalCmb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                montoTotalCmbActionPerformed(evt);
            }
        });

        jLabel10.setText("Monto total");

        montoMensualCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        montoMensualCmb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                montoMensualCmbActionPerformed(evt);
            }
        });

        jLabel12.setText("Monto mensual");

        conRelacionRadioBtn.setText("Con relación");
        conRelacionRadioBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                conRelacionRadioBtnActionPerformed(evt);
            }
        });

        sinRelacionRadioBtn.setText("Sin relación");
        sinRelacionRadioBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sinRelacionRadioBtnActionPerformed(evt);
            }
        });

        categoriaCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        categoriaCmb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                categoriaCmbActionPerformed(evt);
            }
        });

        jLabel11.setText("Categoria");

        dependenciaCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        dependenciaCmb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dependenciaCmbActionPerformed(evt);
            }
        });

        jLabel13.setText("Dependencia");

        jLabel15.setFont(new java.awt.Font("Ubuntu", 1, 15)); // NOI18N
        jLabel15.setText("Configuracion de los campos:");

        jLabel17.setText("Apellido y nombre");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator2, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jSeparator3)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanel3Layout.createSequentialGroup()
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(apellidoNombreCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel17))
                                    .addGap(18, 18, 18)
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(documentoCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel6))
                                    .addGap(18, 18, 18)
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(categoriaCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel11)))
                                .addGroup(jPanel3Layout.createSequentialGroup()
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(duracionMesesCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel7))
                                    .addGap(18, 18, 18)
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(dependenciaCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel13))
                                    .addGap(18, 18, 18)
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(fechaDesdeCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel8))))
                            .addComponent(jLabel5)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(conRelacionRadioBtn)
                                .addGap(18, 18, 18)
                                .addComponent(sinRelacionRadioBtn))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(fechaHastaCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel9))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(montoTotalCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel10))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(montoMensualCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel12)))
                            .addComponent(jLabel15))
                        .addGap(0, 394, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(72, 72, 72)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(conRelacionRadioBtn)
                    .addComponent(sinRelacionRadioBtn))
                .addGap(8, 8, 8)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel15)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanel3Layout.createSequentialGroup()
                                            .addComponent(jLabel17)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(apellidoNombreCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                                            .addComponent(jLabel6)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(documentoCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addGroup(jPanel3Layout.createSequentialGroup()
                                        .addComponent(jLabel11)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(categoriaCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanel3Layout.createSequentialGroup()
                                        .addComponent(jLabel7)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(duracionMesesCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanel3Layout.createSequentialGroup()
                                        .addComponent(jLabel13)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(dependenciaCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jLabel8)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fechaDesdeCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel9)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(fechaHastaCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(montoTotalCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel12)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(montoMensualCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(75, Short.MAX_VALUE))
        );

        tabbedPanel.addTab("Configuracion de datos", jPanel3);

        javax.swing.GroupLayout previsualizationPnlLayout = new javax.swing.GroupLayout(previsualizationPnl);
        previsualizationPnl.setLayout(previsualizationPnlLayout);
        previsualizationPnlLayout.setHorizontalGroup(
            previsualizationPnlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1144, Short.MAX_VALUE)
        );
        previsualizationPnlLayout.setVerticalGroup(
            previsualizationPnlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 385, Short.MAX_VALUE)
        );

        nextBtn.setText(">>");
        nextBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextBtnActionPerformed(evt);
            }
        });

        prevBtn.setText("<<");
        prevBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prevBtnActionPerformed(evt);
            }
        });

        indexLbl.setText("jLabel2");

        printBtn.setText("Imprimir en lote");
        printBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                printBtnActionPerformed(evt);
            }
        });

        printersCmb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel2.setText("Desde");

        jLabel19.setText("Hasta");

        jLabel20.setText("Copias");

        copiasNum.setModel(new javax.swing.SpinnerNumberModel(1, 1, 10, 1));

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(previsualizationPnl, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(prevBtn)
                        .addGap(18, 18, 18)
                        .addComponent(indexLbl)
                        .addGap(18, 18, 18)
                        .addComponent(nextBtn)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel2)
                        .addGap(2, 2, 2)
                        .addComponent(desdeNum, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel19)
                        .addGap(2, 2, 2)
                        .addComponent(hastaNum, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel20)
                        .addGap(2, 2, 2)
                        .addComponent(copiasNum, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(3, 3, 3)
                        .addComponent(printersCmb, javax.swing.GroupLayout.PREFERRED_SIZE, 195, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(printBtn)))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(hastaNum, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel19))
                    .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(nextBtn)
                        .addComponent(prevBtn)
                        .addComponent(indexLbl)
                        .addComponent(printBtn)
                        .addComponent(printersCmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(desdeNum, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel2)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(copiasNum, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel20))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(previsualizationPnl, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedPanel.addTab("Previsualizacion", jPanel5);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(tabbedPanel)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(exitBtn)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tabbedPanel)
                .addGap(18, 18, 18)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(10, 10, 10)
                .addComponent(exitBtn)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void listPathChooserBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_listPathChooserBtnActionPerformed
        JFileChooser jfc = new JFileChooser(FileSystemView.getFileSystemView().getHomeDirectory());
        FileNameExtensionFilter ff = new FileNameExtensionFilter("Excel (*.xls, *.xlsx)", "xls", "xlsx");
        jfc.addChoosableFileFilter(ff);
        jfc.setFileFilter(ff);
        int returnValue = jfc.showOpenDialog(null);

        if (returnValue == JFileChooser.APPROVE_OPTION) {
            File selectedFile = jfc.getSelectedFile();
            this.listPath = selectedFile.getPath();
            this.listPathText.setText(listPath);
            try {
                data = ExcelReader.readFromExcel(listPath);
                addDataToTable(jTable1);
                setColumnsValues();
                int size = data.size() - 1;
                this.cantidadRegistrosTxt.setText(Integer.toString(size));
            } catch (IOException ex) {
                Logger.getLogger(ContratoView.class.getName()).log(Level.SEVERE, null, ex);
            } catch (Exception ex) {
                Logger.getLogger(ContratoView.class.getName()).log(Level.SEVERE, null, ex);

            }
        }
    }//GEN-LAST:event_listPathChooserBtnActionPerformed

    private void addDataToTable(JTable table) {
        table.setModel(new DefaultTableModel(new Object[][]{}, data.get(0).toArray()));
        for (List list : data) {
            if (data.indexOf(list) > 0) {
                ((DefaultTableModel) table.getModel()).addRow(list.toArray());
            }
        }
    }

    private void setColumnsValues() {
        for (JComboBox combo : comboFieldList) {
            List columns = data.get(0);
            combo.removeAllItems();
            for (Object column : columns) {
                combo.addItem(column);
            }
        }
    }

    private void disableNonRequiredFields() {
        comboFieldList.forEach((combo) -> {
            combo.setEnabled(true);
        });
        switch (this.type) {
            case SIN_RELACION:
            case TRANSITO:
                this.categoriaCmb.setEnabled(false);
                break;
            case CON_RELACION:
                this.montoMensualCmb.setEnabled(false);
                this.montoTotalCmb.setEnabled(false);
                break;
            default:
                throw new AssertionError(this.type.name());

        }
    }

    private ContratoAdapter getContratoAdapter() {
        ContratoAdapter contratoAdapter = new ContratoAdapter();
        contratoAdapter.setApellidoNombre(this.apellidoNombreCmb.getSelectedIndex());
        contratoAdapter.setCategoria(this.categoriaCmb.getSelectedIndex());
        contratoAdapter.setDependencia(this.dependenciaCmb.getSelectedIndex());
        contratoAdapter.setDocumento(this.documentoCmb.getSelectedIndex());
        contratoAdapter.setDuracionMeses(this.duracionMesesCmb.getSelectedIndex());
        contratoAdapter.setFechaDesde(this.fechaDesdeCmb.getSelectedIndex());
        contratoAdapter.setFechaHasta(this.fechaHastaCmb.getSelectedIndex());
        contratoAdapter.setMontoMensual(this.montoMensualCmb.getSelectedIndex());
        contratoAdapter.setMontoTotal(this.montoTotalCmb.getSelectedIndex());
        return contratoAdapter;
    }

    private void conRelacionRadioBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_conRelacionRadioBtnActionPerformed
        this.type = ContratoType.CON_RELACION;
        this.disableNonRequiredFields();
    }//GEN-LAST:event_conRelacionRadioBtnActionPerformed

    private void exitBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitBtnActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitBtnActionPerformed

    private void printBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_printBtnActionPerformed
        Double desde = (Double) desdeNum.getValue();
        Double hasta = (Double) hastaNum.getValue();
        Integer copias = (Integer) copiasNum.getValue();
        String impresora = (String) printersCmb.getSelectedItem();
        PrinterJob printerJob = PrinterJob.getPrinterJob();
        PrintService[] services = PrintServiceLookup.lookupPrintServices(null, null);
        PrintService selectedService = getPrintServiceByName(impresora);
        if(selectedService != null) {
            for (Double i = desde; i < hasta; i++) {
                for (int j = 0; j < copias; j++) {
                    try {
                        printerJob.setPrintService(selectedService);
                        Contrato contrato = contratos.get(i.intValue());
                        System.out.println("Imprimiendo : " + i + " "+ contrato.getApellidoNombre() + " copia : "+ (j+1));
                        JasperPrint jasperPrint = contratoCont.generateReport(contrato, type);
                        boolean printSucceed = JasperPrintManager.printReport(jasperPrint, false);
                    } catch (PrinterException | JRException ex) {
                        // Logger.getLogger(ContratoView.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            }
        }

    }//GEN-LAST:event_printBtnActionPerformed

    private PrintService getPrintServiceByName(String name){
        PrintService[] printServices = PrintServiceLookup.lookupPrintServices(null, null);
        for (PrintService printService : printServices) {
            if (printService.getName().equals(name)){
                return printService;
            }
        }
        return null;
    }
    
    private void sinRelacionRadioBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sinRelacionRadioBtnActionPerformed
        this.type = ContratoType.SIN_RELACION;
        this.disableNonRequiredFields();
    }//GEN-LAST:event_sinRelacionRadioBtnActionPerformed

    private void duracionMesesCmbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_duracionMesesCmbActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_duracionMesesCmbActionPerformed

    private void fechaDesdeCmbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fechaDesdeCmbActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fechaDesdeCmbActionPerformed

    private void fechaHastaCmbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fechaHastaCmbActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fechaHastaCmbActionPerformed

    private void montoTotalCmbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_montoTotalCmbActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_montoTotalCmbActionPerformed

    private void montoMensualCmbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_montoMensualCmbActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_montoMensualCmbActionPerformed

    private void categoriaCmbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_categoriaCmbActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_categoriaCmbActionPerformed

    private void dependenciaCmbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dependenciaCmbActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_dependenciaCmbActionPerformed

    private void nextBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextBtnActionPerformed
        if (contratos.size() > contratosIndex) {
            contratosIndex++;
            setIndex();
            previsualize();
        }
    }//GEN-LAST:event_nextBtnActionPerformed

    private void prevBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prevBtnActionPerformed
        if (contratosIndex > 0) {
            contratosIndex--;
            setIndex();
            previsualize();
        }
    }//GEN-LAST:event_prevBtnActionPerformed

    private void tabbedPanelStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_tabbedPanelStateChanged
        if (tabbedPanel.getSelectedIndex() == 2) {
            contratos = this.contratoCont.transform(data, this.getContratoAdapter(), this.type);
            contratosIndex = 0;
            Integer size = contratos.size();
            SpinnerNumberModel desdeModel = new SpinnerNumberModel(0.0, 0.0, size.doubleValue() , 1.0); 
            SpinnerNumberModel hastaModel = new SpinnerNumberModel(0.0, 0.0, size.doubleValue(), 1.0); 
            desdeNum.setModel(desdeModel);
            hastaNum.setModel(hastaModel);
            desdeNum.setValue(0.0);
            hastaNum.setValue(0.0);
            setIndex();
            previsualize();
            PrintService[] printServices = PrintServiceLookup.lookupPrintServices(null, null);
            printersCmb.removeAllItems();
            for (PrintService printService : printServices) {
                printersCmb.addItem(printService.getName());
            }
        }
    }//GEN-LAST:event_tabbedPanelStateChanged

    private void setIndex() {
        indexLbl.setText(String.format("%s de %s", contratosIndex + 1, contratos.size()));
    }

    private void previsualize() {
        try {
            Contrato contrato = this.contratos.get(this.contratosIndex);
            JRViewer viewer = new JRViewer(contratoCont.generateReport(contrato, type));

            previsualizationPnl.removeAll();
            previsualizationPnl.setLayout(new BorderLayout());
            previsualizationPnl.repaint();
            previsualizationPnl.removeAll();
            previsualizationPnl.add(viewer);
            previsualizationPnl.revalidate();
        } catch (JRException ex) {
            Logger.getLogger(ContratoView.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> apellidoNombreCmb;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JLabel cantidadRegistrosTxt;
    private javax.swing.JComboBox<String> categoriaCmb;
    private javax.swing.JRadioButton conRelacionRadioBtn;
    private javax.swing.JSpinner copiasNum;
    private javax.swing.JComboBox<String> dependenciaCmb;
    private javax.swing.JSpinner desdeNum;
    private javax.swing.JComboBox<String> documentoCmb;
    private javax.swing.JComboBox<String> duracionMesesCmb;
    private javax.swing.JButton exitBtn;
    private javax.swing.JComboBox<String> fechaDesdeCmb;
    private javax.swing.JComboBox<String> fechaHastaCmb;
    private javax.swing.JSpinner hastaNum;
    private javax.swing.JLabel indexLbl;
    private javax.swing.JFrame jFrame1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTable jTable1;
    private javax.swing.JButton listPathChooserBtn;
    private javax.swing.JTextField listPathText;
    private javax.swing.JComboBox<String> montoMensualCmb;
    private javax.swing.JComboBox<String> montoTotalCmb;
    private javax.swing.JButton nextBtn;
    private javax.swing.JButton prevBtn;
    private javax.swing.JPanel previsualizationPnl;
    private javax.swing.JButton printBtn;
    private javax.swing.JComboBox<String> printersCmb;
    private javax.swing.JRadioButton sinRelacionRadioBtn;
    private javax.swing.JTabbedPane tabbedPanel;
    // End of variables declaration//GEN-END:variables
}
